/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import * as runtime from '../runtime';
import {Price, PriceFromJSON, PriceToJSON} from '../models';

export interface KuCoinControllerApiGetPricesRequest {
  base: string;
  currencies?: Set<string>;
}

/**
 *
 */
export class KuCoinControllerApi extends runtime.BaseAPI {
  /**
   */
  async getPricesRaw(
    requestParameters: KuCoinControllerApiGetPricesRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<Price>> {
    if (
      requestParameters.base === null ||
      requestParameters.base === undefined
    ) {
      throw new runtime.RequiredError(
        'base',
        'Required parameter requestParameters.base was null or undefined when calling getPrices.'
      );
    }

    const queryParameters: any = {};

    if (requestParameters.base !== undefined) {
      queryParameters['base'] = requestParameters.base;
    }

    if (requestParameters.currencies) {
      queryParameters['currencies'] = requestParameters.currencies;
    }

    const headerParameters: runtime.HTTPHeaders = {};

    const response = await this.request(
      {
        path: `/api/kucoin/price`,
        method: 'GET',
        headers: headerParameters,
        query: queryParameters,
      },
      initOverrides
    );

    return new runtime.JSONApiResponse(response, (jsonValue) =>
      PriceFromJSON(jsonValue)
    );
  }

  /**
   */
  async getPrices(
    requestParameters: KuCoinControllerApiGetPricesRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<Price> {
    const response = await this.getPricesRaw(requestParameters, initOverrides);
    return await response.value();
  }
}
